;
;
;	MOPS editor funkcik karaktermegjelent rutinjai VT-DOS-ra
;
;


;
;	VT-DOS konzol kurzor kikapcsolsa
;	in:  -
;	out: -
;
ed_dosoff:
	ld	e,00Ch			; kperny trlse
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa

ed_dosoff_noclr:
	ld	e,01Bh			; ESC szekvencia kezdete
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ld	e,'x'			; kurzor kikapcsolsa
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ld	e,'5'
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ret


;
;	VT-DOS konzol kurzor bekapcsolsa
;	in:  -
;	out: -
;
ed_doson:
	ld	e,00Ch			; kperny trlse
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa

ed_doson_noclr:
	ld	e,01Bh			; ESC szekvencia kezdete
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ld	e,'y'			; kurzor bekapcsolsa
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ld	e,'5'
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ret


;
;	Fix karaktermtrix kezdcmnek belltsa
;	in:  DE - karaktermtrix cme (020h karakter mtrixval kezddik)
;	out: -
;
ed_setfix:
	push	hl
	ex	de,hl
	ld	de,-320			; 32 karakternyi cm kivonsa
	add	hl,de
	ld	(fix_chars),hl
	pop	hl
	ret


;
;	Definilhat karaktermtrix kezdcmnek belltsa
;	in:   C - legutols hasznlt karakter kdja (127..223)
;	     DE - karaktermtrix cme (128..223 kdok -> max. 96 karakatert tartalmaz)
;	out: -
;
ed_setdef:
	push	hl
	ex	de,hl
	ld	de,-1280		; 128 karakternyi cm kivonsa
	add	hl,de
	ld	(def_chars),hl
	ld	a,c			; utols hasznlt karakter belltsa
	cp	127
	jr	nc,ed_std0
	ld	a,127
ed_std0:cp	224
	jr	c,ed_std1
	ld	a,223
ed_std1:ld	(last_def_char),a
	pop	hl
	ret


;
;	VIDEO 04 - VID-MODE: a videozemmd belltsa
;	in:   C - az zemmd kdja (0,1,2)
;	out:  A - hibakd: 000h - rendben  0F7h - nincs ilyen zemmd
;
ed_vidmode:
	ld	a,c
	cp	003h
	ld	a,0F7h
	ret	nc
	ld	a,c
	ld	(vidmode),a
	ld	a,001h
	cp	c
	jr	nc,LCA15		; ugrs, ha 2 vagy 4-szn md
	in	a,(059h)		; sznkapcsol vizsglata
	rlca
	rlca
	ld	a,00Fh
	jr	nc,LCA15
	ld	a,00Ch
LCA15:	ld	d,a			; INK
	ld	e,000h			; PAPER
	call	ed_setcolors
	push	bc
	call	ed_cls			; kpernytrls
	pop	bc
	ld	a,c
	out	(006h),a		; zemmd belltsa (+hang amplitd nullzsa)
	in	a,(059h)		; sznkapcsol vizsglata
	rlca
	rlca
	ld	de,LC9EE
	jr	nc,ed_paldef
	ld	de,LC9EA


;
;	VIDEO 12 - PAL-DEF: palettasznek definilsa
;	in:  DE - 4 bjtos memriaterlet cme a palettartkekkel
;	out:  A - hibakd: 000h
;
ed_paldef:
	ld	a,(de)
	out	(060h),a
	inc	de
	ld	a,(de)
	out	(061h),a
	inc	de
	ld	a,(de)
	out	(062h),a
	inc	de
	ld	a,(de)
	out	(063h),a
	xor	a
	ret


;
;	Palettaregiszterek alaprtkei
;
LC9EA:	.db	000h, 050h, 044h, 041h		; sznes mdban
LC9EE:	.db	000h, 055h, 050h, 044h		; fekete-fehr mdban


;
;	VIDEO 05 - CLS: kpernytrls
;	in:  -
;	out: -
;
ed_cls:	push	hl
	ld	a,(0003Bh)
	push	af
	ld	a,090h			; memrialapozs: U0, U1, VID, U3
	ld	(0003Bh),a		; felhasznli lapozs elmentse
	out	(002h),a		; lapozs a porton
;
	ld	hl,00101h		; kurzor s sorhossz belltsa
	ld	(kurzor_poz),hl
	ld	a,(vidmode)
	ld	b,040h
	or	a
	jr	z,ed_inc0
	ld	b,020h
	dec	a
	jr	z,ed_inc0
	ld	b,010h
ed_inc0:ld	a,b
	ld	(sorhossz),a
;
	ld	hl,08000h		; kperny trlse
	ld	de,08001h
	ld	a,(vonal_bytes+1)	; A reg.= PAPER szn vonalbjt
	ld	(hl),a
	ld	bc,03BFFh
	ldir
	pop	af			; felhasznli lapozs vissza
	ld	(0003Bh),a
	out	(002h),a
	pop	hl
	ret


;
;
;	EDITOR 03 - CUPOS: Kurzor pozcionlsa
;	in:   B - oszlop (soron belli pozci)
;	      C - sor (1..24)
;	out:  A - 000h -> nincs hiba  0F6h -> nem lehetsges pozci
;
ed_cpos:push	hl
	ld	hl,(kurzor_poz)
	ld	a,b
	or	a
	jr	z,LD02B
	ld	a,(sorhossz)
	cp	b
	jr	c,LD03E
	ld	h,b
LD02B:	ld	a,c
	or	a
	jr	z,LD035
	ld	a,018h
	cp	c
	jr	c,LD03E
	ld	l,c
LD035:	ld	(kurzor_poz),hl
	pop	hl
	xor	a
	ret
;
LD03E:	pop	hl
	ld	a,0F6h
	ret


;
;
;	EDITOR 02 - BKOUT: Meghatrozott mret karakterblokk kirsa
;	in:  BC - a kirand karakterek szma
;	     DE - a karakterek kezdcme a memriban
;	out: -
;
ed_bkout:
	push	hl
	exx
	push	hl
	push	de
	push	bc
	exx
	ld	a,(0003Bh)
	push	af
	ld	a,090h			; memrialapozs: U0, U1, VID, U3
	ld	(0003Bh),a		; felhasznli lapozs elmentse
	out	(002h),a		; lapozs a porton
	ex	de,hl			; memriacm HL-be
ed_bk0:	push	hl
	push	bc
	ld	c,(hl)
	call	LD0C2
	pop	bc
	pop	hl
	cpi				; BC= BC-1  HL= HL+1
	jp	pe,ed_bk0
ed_bk1:	ex	de,hl
	jp	ed_ch1


;
;
;	EDITOR 01 - CHOUT: Karakterkiklds
;	in:  C - karakterkd
;	out: -
;
ed_chout:
	push	hl
	exx
	push	hl
	push	de
	push	bc
	exx
	ld	a,(0003Bh)
	push	af
	ld	a,090h			; memrialapozs: U0, U1, VID, U3
	ld	(0003Bh),a		; felhasznli lapozs elmentse
	out	(002h),a		; lapozs a porton
	call	LD0C2
ed_ch1:	pop	af			; felhasznli lapozs vissza
	ld	(0003Bh),a
	out	(002h),a
	exx
	pop	bc
	pop	de
	pop	hl
	exx
	pop	hl
	xor	a
	ret


;
;
;	Kirand karakter feldolgozsa
;	in:  C - feldolgozand ASCII kd
;	out: -
;
LD0C2:	ld	a,c
	cp	00Dh
	jr	nz,LD0CD		; ugrs, ha nem RETURN karakter
	ld	a,001h
	ld	(kurzor_poz + 1),a	; kurzor a sor elejre
	ret
;
LD0CD:	cp	00Ah
	jr	nz,LD10G		; ugrs, ha nem soremels
	ld	bc,(kurzor_poz)
	jr	LD14G			; ugrs a sor nvelshez
;
LD10G:	cp	009h
	jr	nz,LD124		; ugrs, ha nem TAB
	ld	bc,(kurzor_poz)
	ld	a,b
	dec	a			; A reg.= oszlop-pozci 0-tl szmozva
	and	0F8h			; als 3 bit maszkolsa
	add	a,009h			; TAB mret (8) + 1 hozzadsa
	ld	b,a
	jr	LD13G			; ugrs a sorvg ellenrzsre
;
LD124:	cp	020h
	jr	c,LD157			; ugrs, ha vezrlkarakter
	cp	0E0h
	jr	nc,LD157		; ugrs, ha vezrlkarakter
	ld	a,(last_def_char)	; A reg.= utols hasznlhat definilt karakter
	cp	c
	jr	nc,LD12G
	ld	c,020h			; nem definilt karakter helyettestse szkzzel
LD12G:	ld	a,c			; karakterkd ismt A reg.-be
	ld	bc,(kurzor_poz)
	push	bc
	call	LD420
	pop	bc
	inc	b			; kurzor jobbra lptetse
LD13G:	ld	a,(sorhossz)
	cp	b
	jr	nc,LD152
	ld	b,001h
LD14G:	inc	c
	ld	a,c
	cp	019h
	jr	c,LD152
	ld	c,018h
	push	bc			; kperny felfel scrollozsa
	ld	de,08000h
	ld	hl,08280h
	ld	bc,03980h
	ldir
	ld	h,d			; j sor kitltse PAPER sznnel
	ld	l,e
	inc	de
	ld	a,(vonal_bytes+1)	; A reg.= PAPER szn vonalbjt
	ld	(hl),a
	ld	bc,0027Fh
	ldir
	pop	bc
LD152:	ld	(kurzor_poz),bc
LD157:	xor	a
	ret


;
;
;	Karaktermegjelents az ASCII kd alapjn
;	in:   A - karakterkd
;	     BC - a kurzor aktulis pozcija
;	out: -
;
LD420:	ex	af,af'
	call	LD459			; video memriacm ellltsa a kurzorpozcibl
	push	hl
	ex	af,af'
	ld	c,a
	ld	b,000h
	ld	l,c
	ld	h,b
	add	hl,hl
	add	hl,hl
	add	hl,bc
	add	hl,hl
	bit	7,c
	ld	bc,(fix_chars)		; BC= fix karakterek mtrixnak cme a vltozbl
	jr	z,LD439
	ld	bc,(def_chars)		; BC= definilhat karakterek mtrixnak cme a vltozbl
LD439:	add	hl,bc
	ld	b,00Ah
	exx
	ld	bc,(vonal_bytes)	; B= PAPER szn vonalbjt  C= INK szn vonalbjt
	pop	hl
	ld	a,(vidmode)		; ugrs a grafikus mdnak megfelel karakterrajzol rutinra
	or	a
	jr	z,LD3AD			;  2-szn md
	dec	a
	jr	z,LD3BC			;  4-szn md
	jp	LD3D9			; 16-szn md


;
;
;	Karaktermegjelents 2-szn zemmdban
;	in:   B - PAPER szn vonalbjt
;	      C - INK szn vonalbjt
;	     HL - karakter kezdcme a videomemriban
;	      B'- a karakter TV sorainak szma (00Ah)
;	     HL'- karaktermtrix kezdcme
;	out: -
;
LD3AD:	ld	de,00040h
	exx
LD3B1:	ld	a,(hl)
	exx
	and	c
	xor	b
	ld	(hl),a
	add	hl,de
	exx
	inc	hl
	djnz	LD3B1
	ret


;
;
;	Karaktermegjelents 4-szn zemmdban
;	in:   B - PAPER szn vonalbjt
;	      C - INK szn vonalbjt
;	     HL - karakter kezdcme a videomemriban
;	      B'- a karakter TV sorainak szma (00Ah)
;	     HL'- karaktermtrix kezdcme
;	out: -
;
LD3BC:	exx
LD3BD:	ld	a,(hl)
	exx
	ld	d,a
	rrca
	rrca
	rrca
	rrca
	xor	d
	and	c
	ld	e,a
	and	00Fh
	xor	d
	and	c
	xor	b
	ld	(hl),a
	inc	l
	xor	e
	ld	(hl),a
	ld	de,0003Fh
	add	hl,de
	exx
	inc	hl
	djnz	LD3BD
	ret


;
;	Karaktermegjelents 16-szn zemmdban
;	in:   B - PAPER szn vonalbjt
;	      C - INK szn vonalbjt
;	     HL - karakter kezdcme a videomemriban
;	      B'- a karakter TV sorainak szma (00Ah)
;	     HL'- karaktermtrix kezdcme
;	out: -
;
LD3D9:	exx
LD3DA:	ld	a,(hl)
	exx
	rla
	ld	e,a
	sbc	a,a
	ld	d,a
	rl	e
	sbc	a,a
	xor	d
	and	055h
	xor	d
	and	c
	xor	b
	ld	(hl),a
	inc	l
	rl	e
	sbc	a,a
	ld	d,a
	rl	e
	sbc	a,a
	xor	d
	and	055h
	xor	d
	and	c
	xor	b
	ld	(hl),a
	inc	l
	rl	e
	sbc	a,a
	ld	d,a
	rl	e
	sbc	a,a
	xor	d
	and	055h
	xor	d
	and	c
	xor	b
	ld	(hl),a
	inc	l
	rl	e
	sbc	a,a
	ld	d,a
	rl	e
	sbc	a,a
	xor	d
	and	055h
	xor	d
	and	c
	xor	b
	ld	(hl),a
	ld	de,0003Dh
	add	hl,de
	exx
	inc	hl
	djnz	LD3DA
	ret


;
;
;	Video memriacm ellltsa a kurzorpozcibl
;	in:  BC - a kurzor aktulis pozcija
;	out: HL - kiszmtott memriacm
;
LD459:	dec	b
	ld	a,(vidmode)
	or	a
	jr	z,LD465
LD460:	sla	b
	dec	a
	jr	nz,LD460
LD465:	dec	c
	ld	a,c
	add	a,a
	add	a,a
	add	a,c
	add	a,a
	ld	h,a
	xor	a
	srl	h
	rra
	scf
	rr	h
	rra
	or	b
	ld	l,a
	ret


;
;
;	PAPER s INK szn vonalbjtok ellltsa
;	in:   D - INK sorszma (0..1, 0..3, 0..15)
;	      E - PAPER sorszma (0..1, 0..3, 0..15)
;	out: -
;
ed_setcolors:
	push	hl
	ld	a,e
	call	LCC10
	ld	(vonal_bytes+1),a	; PAPER szn vonalbjt
	ld	e,a
	ld	a,d
	call	LCC10
	xor	e
	ld	(vonal_bytes),a		; INK szn vonalbjt
	pop	hl
	ret


;
;
;	Adott szn vonalbjt ellltsa
;	in:   A - sznkd vagy palettasorszm
;	out:  A - vonalbjt
;
LCC10:	ld	hl,(vidmode)
	srl	l
	jr	c,LCC20			; ugrs, ha 4-szn md
	srl	l
	jr	c,LCC31			; ugrs, ha 16-szn md
	and	001h
	rra
	sbc	a,a
	ret
;
LCC20:	and	003h
	rra
	rl	l
	rra
	sbc	a,a
	rr	l
	rra
	sra	a
	sra	a
	sra	a
	ret
;
LCC31:	and	00Fh
	ld	h,004h
LCC35:	rra
	rr	l
	sra	l
	dec	h
	jr	nz,LCC35
	ld	a,l
	ret


;
.end
