;
;	Grafikus karakterek VT-DOS-ra
;
;
;


	.org 0100h			; a VT-DOS programok betltsi cme


pmain:	ld	sp,07FF0h		; sajt veremterlet kialaktsa U1 tetejn
;
	call	ed_dosoff		; VT-DOS kurzor kikapcsolsa
	ld	de,fix_chmatrix
	call	ed_setfix
	ld	c,169			; C = az utols definlt karakter kdja
	ld	de,def_chmatrix
	call	ed_setdef
;
	call	intro			; intro kirsa 4-szn mdban
;
	ld	c,002h			; 16-szn md
	call	ed_vidmode
	ld	d,14			; INK
	ld	e,3			; PAPER
	call	ed_setcolors
	ld	hl,rul16c
	call	ut_prnt			; fejlc kirsa
;
	ld	h,1			; H= X koordinta (1..16)
	ld	l,5			; L= Y koordinta (1..24)
	ld	(playerY),hl
	ld	h,16			; H= X koordinta (1..16)
	ld	l,12			; L= Y koordinta (1..24)
	ld	(szornyY),hl
;
demo:	ld	d,5			; INK
	ld	e,0			; PAPER
	call	ed_setcolors
	ld	hl,(playerY)
	ld	c,32
	call	print_at_hl		; jtkos trlse
	inc	h			; pozci frisstse
	ld	(playerY),hl
	ld	c,161
	call	print_at_hl		; grafikus karakter kirsa a HL-ben adott koordintra
;
	ld	d,4			; INK
	ld	e,0			; PAPER
	call	ed_setcolors
	ld	hl,(szornyY)
	ld	c,32
	call	print_at_hl		; szrny trlse
	dec	h			; pozci frisstse
	ld	(szornyY),hl
	ld	c,169
	call	print_at_hl		; szrny kirajzolsa
;
	ld	b,10			; vrakozs
pvar:	halt
	djnz	pvar
	ld	a,(szornyX)
	dec	a
	jr	nz,demo			; ugrs, ha a szrny mg nem rte el a kp bal szlt
;
	ld	b,1			; pozci a lblchez
	ld	c,20
	call	ed_cpos
	ld	d,13			; INK
	ld	e,6			; PAPER
	call	ed_setcolors
	ld	hl,press
	call	ut_prnt			; gombnyoms krs kirsa
;
	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
;
exit:	ld	c,000h			; 2-szn md
	call	ed_vidmode
	call	ed_doson		; VT-DOS kurzor bekapcsolsa
	jp	0000h			; vissza a VT-DOS-ba


;
;
;	Intro kirsa
;	in:  -
;	out: -
;
intro:
	ld	c,001h			; 4-szn md
	call	ed_vidmode
	ld	de,rulep		; DE= paletta cme
	call	ed_paldef		; j paletta belltsa
	ld	d,1			; INK
	ld	e,3			; PAPER
	call	ed_setcolors
	ld	hl,rulhead
	call	ut_prnt			; fejlc kirsa
	ld	d,1			; INK
	ld	e,0			; PAPER
	call	ed_setcolors
	ld	hl,rules
	call	ut_prnt			; szveg kirsa
	ld	d,2			; INK
	ld	e,0			; PAPER
	call	ed_setcolors
	ld	hl,press
	call	ut_prnt			; gombnyoms krs kirsa
	ld	hl,00844h		; H = sznvlts ksleltetse  L = a kirs sznkdja
intr0:	push	hl			; palettartk mentse
	ld	e,0FFh			; input jelzse
	ld	c,006h			; lenyomott gomb beolvassa (kzvetlen konzol input)
	call	0005h			; VT-DOS hvsa
	pop	hl
	or	a
	ret	nz			; visszatrs, ha nyomtak gombot
	halt
	dec	h
	jr	nz,intr0
	ld	h,008h			; ksleltets belltsa
	ld	a,l
	inc	a			; sznrtk nvelse
	or	040h			; csak a magas intenzits szneket hasznlja
	ld	l,a
	out	(062h),a		; j szn belltsa
	jr	intr0

;
;	Paletta a 4-szn szveg kirshoz
;
rulep	.db	000h, 055h, 044h, 041h	; fekete, fehr, piros, kk


;
;	Karakter kirsa a kperny adott pozcijba
;	in:   C - kirand karakter
;	      H - oszlop pozci (1..16 v. 1..32 v. 1..64)
;	      L - sor pozci (1..24)
;	out: BC - megrzdik
;	     HL - megrzdik
;
print_at_hl:
	push	bc
	push	hl
	push	bc
	ld	b,h
	ld	c,l
	call	ed_cpos
	pop	bc
	call	ed_chout
	pop	hl
	pop	bc
	ret


;
;	Szveg kirsa az aktulis karakteres pozciba
;	in:  HL - 0-val lezrt string kezdete
;	out: HL - a lezr nulla utni cm
;
ut_prnt:ld	a,(hl)
	inc	hl
	or	a
	ret	z
	call	ut_cch			; ISO kezetes karakterek konvertlsa
	ld	c,a			; C= karakterkd
	call	ed_chout		; karakter kirsa
	jr	ut_prnt


;
;
;	ISO 8859-2 s Win 1250-es kdols kezetes karakterek konvertlsa
;	in:   A - ASCII karakterkd
;	out:  A - konvertlt karakterkd
;
ut_cch:	cp	0C1h
	ret	c			; visszatrs, ha nem kezetes karakter
	push	hl			; karakter konvertlsa
	ld	bc,0009h		; 9 kezetes bet ellenrzse
	ld	hl,smalett		; kisbetk kdjai
	cp	0E1h
	jr	nc,ut_cch0		; ugrs, ha kisbet lehet
	ld	hl,caplett		; nagybetk kdjai
ut_cch0:cpir
	pop	hl
	ret	nz			; visszatrs, ha nem kezetes bet
	ld	a,098h			; A reg.= '' kdja + 8
	jr	nc,ut_cch1		; ugrs, ha kisbet
	ld	a,088h			; A reg.= '' kdja + 8
ut_cch1:sub	c
	ret

;
;	kezetes nagy- s kisbetk ISO 8859-2 szerinti kdjai
;
caplett	.db	0C1h,0C9h,0CDh,0D3h,0D6h,0D5h,0DAh,0DCh,0DBh
smalett	.db	0E1h,0E9h,0EDh,0F3h,0F6h,0F5h,0FAh,0FCh,0FBh
;



;
; Kls modulokbl beillesztend programrszek
;

;
	#include "editor.asm"
;
fix_chmatrix:
;
	#include "fix_char.asm"
;
def_chmatrix:
;
	#include "def_char.asm"
;

;
;	Sajt definilt karakterek (ASCII 160..169)
;
;	megj.: kzvetlenl a "def_char.asm" include-olsa utn kell elhelyezni
;

	.db	28,60,28,8,127,13,12,28,22,50
	.db	56,60,56,16,254,176,48,56,104,76
	.db	112,122,113,32,103,120,97,114,208,152
	.db	14,94,142,4,230,30,134,78,11,25
	.db	56,56,58,18,254,184,184,40,40,108
	.db	56,56,16,40,40,186,254,16,146,84
	.db	170,85,170,85,170,85,170,85,170,85
	.db	66,66,126,66,66,66,66,126,66,66
	.db	0,0,0,0,24,60,24,0,0,0
	.db	28,62,127,73,73,127,85,107,62,28


;
;	Konstansok
;

rulhead	.text	"    \241 Grafikus karakterek \240     \r\n\r\n\000"
;
rules	.text	"Ez a program a grafikus karakte-"
	.text	"rek hasznlatt mutatja be      "
	.text	"VT-DOS rendszer alatt:\r\n\r\n"
	.text	"      \240 \241 \242 \243 \244 \245 \246 \247 \250 \251\r\n\r\n\000"
;
press	.text	" Nyomjon meg egy billentyt !!! \000"
;
rul16c	.text	"  16 szn md  \000"

;
;	Vltozk
;

	#include "ed_data.asm"
;
datamem	.equ	eddataend		; az els szabad memriacm az editor vltozk utn
;
playerY	.equ	datamem + 0		; jtkos Y koordintja
playerX	.equ	datamem + 1		; jtkos X koordintja
szornyY	.equ	datamem + 2		; szrny  Y koordintja
szornyX	.equ	datamem + 3		; szrny  X koordintja



.end

